﻿using System;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Windows.Forms;

namespace AplikacjaOkienkowa
{
    public partial class Form1 : Form
    {
        private const string OutputFileName = "slownik.txt";

        public Form1()
        {
            InitializeComponent();

        }

        private void button2_Click(object sender, EventArgs e)
        {
			string data = ExportData();
            string outputFile = string.Format(CultureInfo.CurrentCulture, "{0}\\{1}", Path.GetTempPath(), OutputFileName);
			
			using( var writer = new StreamWriter(outputFile))
            {
			    writer.WriteLine(data);
            }

            using (var exportProcess = new Process())
            {
                exportProcess.StartInfo.FileName = outputFile;
                exportProcess.StartInfo.UseShellExecute = true;
                exportProcess.Start();
            }
        }

        private string ExportData()
        {
            string data = "";
            foreach (ListViewItem item in wordList.Items)
            {
                data += item.SubItems[0].Text;
                data += "\t";
                data += item.SubItems[1].Text;
                data += "\r\n";
            }
            return data;
        }

        private void CzytajSlowa(string nazwaPliku)
        {
            wordList.Items.Clear();
            var slownik = new Slownik();
            slownik.Czytaj(nazwaPliku);
            foreach (var slowo in slownik.ListaSlow())
                wordList.Items.Add((new ListViewItem(new[] { slowo.Tekst, slowo.Ilosc.ToString(CultureInfo.CurrentCulture) })));
            dictWordsLabel.Text = slownik.IloscSlow.ToString();
            fileWordsLabel.Text = slownik.IloscWszystkichSlow.ToString();
        }

        private void readButton_Click(object sender, EventArgs e)
        {
            //openFileDialog1.InitialDirectory = System.;
            openFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() != DialogResult.OK) return;
            try
            {
                CzytajSlowa(openFileDialog1.FileName);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Wystąpił błąd podczas odczytu z pliku. Tekst błedu: " + ex.Message);
            }
        }
    }
}
