using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Text.RegularExpressions;

namespace AplikacjaOkienkowa
{
    public class Slownik
    {
        private readonly List<Slowo> _listaSlow;

        public int IloscSlow {
            get { return _listaSlow.Count; }
           
        }
        public int IloscWszystkichSlow { private set; get; }

        public Slownik()
        {
            _listaSlow = new List<Slowo>();
        }

        public void Czytaj(string nazwaPliku)
        {
            FileStream plik = File.Open(nazwaPliku, FileMode.Open, FileAccess.Read);
            var sr = new StreamReader(plik);
            string tekst = sr.ReadToEnd();
            sr.Close();
            plik.Close();

            //String[] slowa = Regex.Split(tekst, @"[^a-zA-Z]+");
            String[] slowa = Regex.Split(tekst, @"[\W\d_]+");
            foreach (var s in slowa)
            {
                DodajSlowo(s.ToLower());
            }
        }

        public IEnumerable<Slowo> ListaSlow()
        {
            _listaSlow.Sort((a, b) => String.Compare(a.Tekst, b.Tekst, false,CultureInfo.CurrentCulture));
            return _listaSlow;
        }

        public void DodajSlowo(string slowo)
        {
            if (slowo.Length == 0) return;

            IloscWszystkichSlow ++;
            
            foreach (var s in _listaSlow)
            {
                if (s.Tekst == slowo)
                {
                    s.Ilosc ++;
                    return;
                }
            }
           _listaSlow.Add(new Slowo(slowo,1) );
        }
    }
}
